 #include "lpc2300.h"  
 #include <string.h>
 #include "uart23xx.c"
 #include "diskio.c"
 #include "ff.c"
 #include "mci_23xx.c"
 #include "xprintf.c"
 #include "integer.h"
 #include "rtc\rtc23xx.c"
 #include "delay.h"


FATFS Fs[_VOLUMES];	
FIL File[2];				
DIR Dir;					
BYTE Buff[1024] __attribute__ ((aligned (4))) ;

RTC rtc;
void ioinit(void);


		
volatile UINT timer=0;



static
void put_rc (FRESULT rc)
{
	const char *str =
		"OK\0" "DISK_ERR\0" "INT_ERR\0" "NOT_READY\0" "NO_FILE\0" "NO_PATH\0"
		"INVALID_NAME\0" "DENIED\0" "EXIST\0" "INVALID_OBJECT\0" "WRITE_PROTECTED\0"
		"INVALID_DRIVE\0" "NOT_ENABLED\0" "NO_FILE_SYSTEM\0" "MKFS_ABORTED\0" "TIMEOUT\0"
		"LOCKED\0" "NOT_ENOUGH_CORE\0" "TOO_MANY_OPEN_FILES\0";
	FRESULT i;

	for (i = 0; i != rc && *str; i++) {
		while (*str++) ;
	}
	xprintf("rc=%u FR_%s\n", (UINT)rc, str);
}

static
void show_disk_status (		/* Show physical disk status */
	BYTE drv
)
{
	DWORD dw;
	BYTE ct, buf[64];
	WORD w;
	char *ty, *am;


	xprintf("rc=%d\n", disk_status(drv));

	if (disk_ioctl(drv, GET_SECTOR_COUNT, &dw) == RES_OK)
		xprintf("Drive size: %lu sectors\n", dw);

	if (disk_ioctl(drv, GET_BLOCK_SIZE, &dw) == RES_OK)
		xprintf("Erase block size: %lu sectors\n", dw);

	if (disk_ioctl(drv, MMC_GET_TYPE, &ct) == RES_OK) {
		ty = "Unknown"; am = "";
		if (ct & CT_MMC) ty = "MMC";
		if (ct & CT_SD1) ty = "SDv1";
		if (ct & CT_SD2) {
			ty = "SDv2";
			am = (ct & CT_BLOCK) ? "(Block)" : "(Byte)";
		}
		xprintf("Card type: %s%s\n", ty, am);
	}

	if (disk_ioctl(drv, MMC_GET_CSD, buf) == RES_OK) {
		xputs("CSD:\n");
		put_dump(buf, 0, 16, DW_CHAR);
	}

	if (disk_ioctl(drv, MMC_GET_CID, buf) == RES_OK) {
		xputs("CID:\n");
		put_dump(buf, 0, 16, DW_CHAR);
	}

	if (disk_ioctl(drv, MMC_GET_OCR, buf) == RES_OK) {
		xputs("OCR:\n");
		put_dump(buf, 0, 4, DW_CHAR);
	}

	if ((ct & CT_SDC) && disk_ioctl(drv, MMC_GET_SDSTAT, buf) == RES_OK) {
		xputs("SD Status:\n");
		for (w = 0; w < 64; w += 16)
			put_dump(buf+w, w, 16, DW_CHAR);
	}
}


DWORD get_fattime ()
{
	
	/* Get local time */
	rtc_gettime(&rtc);


	return	  ((DWORD)(rtc.year - 1980) << 25)
			| ((DWORD)rtc.month << 21)
			| ((DWORD)rtc.mday  << 16)
			| ((DWORD)rtc.hour  << 11)
			| ((DWORD)rtc.min   << 5)
			| ((DWORD)rtc.sec   >> 1);
}



__irq void isr_timer0(void)
{
	T0IR=0X01;
	
	 MCI_timerproc();
  VICVectAddr=0;	
}
void ioinit()
{
	 SCS|=0x09;
	
   T0CTCR = 0;
 	 T0MR0 =11059;	/* 1ms timer0 */
	 T0MCR = 0x3;			
	
  	VICIntSelect=0;
   VICIntEnable=1<<4;
   VICVectAddr4=(unsigned int)isr_timer0;
   T0TCR = 1;
}

int main(void)
{
FATFS *fs;
char *ptr;
  unsigned short p1;
	unsigned long p2[3];
	BYTE res;
	int i,k;

ioinit();
uart1_init();		
xdev_in(uart1_getc);
xdev_out(uart1_putc);

xprintf("AKM Electronic\n");
put_rc( MCI_initialize());
put_rc(f_mount(&Fs[0],"",0));
show_disk_status(0);
put_rc(f_open(&File[0],"AKM.txt",6));

	
while(1)
{


}
}


